"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Some inspiration from https://github.com/sveltejs/svelte-loader/blob/master/index.js
// License: https://github.com/sveltejs/svelte-loader#license
var url = require("url");
var paperclip_1 = require("paperclip");
var paperclip_cli_1 = require("paperclip-cli");
var path = require("path");
var resolve = require("resolve");
var loaderUtils = require("loader-utils");
var VirtualModules = require("webpack-virtual-modules");
var _engine;
var getEngine = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (_engine) {
                    return [2 /*return*/, _engine];
                }
                return [4 /*yield*/, paperclip_1.createEngine({})];
            case 1: return [2 /*return*/, (_engine = _a.sent())];
        }
    });
}); };
var virtualModuleInstances = new Map();
var _loadedStyleFiles = {};
function pcLoader(source, virtualModules, resourceUrl) {
    return __awaiter(this, void 0, void 0, function () {
        var callback, _a, resourceProtocol, _b, configFile, config, configFilePath, engine, compiler, info, ast, e_1, info_1, sheet, exports, styleCache, code, sheetCode, sheetFilePath, sheetFileName;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    this.cacheable();
                    callback = this.async();
                    _a = loaderUtils.getOptions(this) || {}, resourceProtocol = _a.resourceProtocol, _b = _a.configFile, configFile = _b === void 0 ? paperclip_1.PC_CONFIG_FILE_NAME : _b;
                    configFilePath = path.join(process.cwd(), configFile);
                    try {
                        config = require(configFilePath);
                    }
                    catch (e) {
                        throw new Error("Config file could not be loaded: " + configFilePath);
                    }
                    return [4 /*yield*/, getEngine()];
                case 1:
                    engine = _c.sent();
                    compiler = require(resolve.sync(config.compilerOptions.name, {
                        basedir: process.cwd()
                    }));
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, 5, , 6]);
                    // need to update virtual content to bust the cache
                    return [4 /*yield*/, engine.updateVirtualFileContent(resourceUrl, source)];
                case 3:
                    // need to update virtual content to bust the cache
                    _c.sent();
                    ast = engine.parseContent(source);
                    return [4 /*yield*/, engine.run(resourceUrl)];
                case 4:
                    info = _c.sent();
                    return [3 /*break*/, 6];
                case 5:
                    e_1 = _c.sent();
                    info_1 = e_1 && e_1.location ? e_1 : e_1.info && e_1.info.location ? e_1.info : null;
                    if (info_1 && info_1.location) {
                        console.error(paperclip_cli_1.getPrettyMessage(info_1, source, resourceUrl, process.cwd()));
                    }
                    return [2 /*return*/, callback(new Error("Could not compile. See further up for details."))];
                case 6:
                    sheet = info.sheet, exports = info.exports;
                    styleCache = __assign({}, _loadedStyleFiles);
                    _loadedStyleFiles = styleCache;
                    code = compiler.compile({ ast: ast, classNames: exports.style.classNames }, resourceUrl, config.compilerOptions);
                    sheetCode = paperclip_1.stringifyCSSSheet(sheet, {
                        uri: resourceUrl,
                        protocol: resourceProtocol
                    });
                    sheetFilePath = url.fileURLToPath(resourceUrl + ".css");
                    sheetFileName = path.basename(sheetFilePath);
                    // covers bug with node@10.13.0 where paths aren't stringified correctly (C:/this/path/is/bad)
                    if (process.platform === "win32") {
                        sheetFilePath = sheetFilePath.replace(/\/+/g, "\\");
                    }
                    virtualModules.writeModule(sheetFilePath, sheetCode);
                    code = "import \"./" + sheetFileName + "\";\n" + code;
                    callback(null, code);
                    return [2 /*return*/];
            }
        });
    });
}
module.exports = function (source) {
    if (this._compiler && !virtualModuleInstances.has(this._compiler)) {
        var modules = activatePlugin(new VirtualModules(), this._compiler);
        virtualModuleInstances.set(this._compiler, modules);
    }
    var virtualModules = virtualModuleInstances.get(this._compiler);
    var resourcePath = this.resourcePath;
    var resourceUrl = url.pathToFileURL(resourcePath).href;
    return pcLoader.call(this, source, virtualModules, resourceUrl);
};
var activatePlugin = function (plugin, compiler) {
    var inputFileSystem = compiler.inputFileSystem, name = compiler.name, context = compiler.context, hooks = compiler.hooks;
    plugin.apply({
        inputFileSystem: inputFileSystem,
        name: name,
        context: context,
        hooks: __assign(__assign({}, hooks), { afterResolvers: makeImmediateCallbackHook(hooks.afterResolvers), afterEnvironment: makeImmediateCallbackHook(hooks.afterEnvironment) })
    });
    return plugin;
};
var makeImmediateCallbackHook = function (hook) { return ({
    tap: function (name, callback) {
        hook.tap(name, callback);
        callback();
    }
}); };
